/* ========================================================================
 * Copyright (c) 2011 The University of Washington
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ========================================================================
 */

#include <sys/types.h>
#include <curl/curl.h>

#define LOGNAME "gwsd"

#define LOCKFILE "/var/log/gwsd.pid"

/* Messages from module  (all unix sockets) */

#define CMD_MEMBER_OF   1
#define CMD_PASSWORD   2
#define MSG_ID_LEN  64
#define MSG_GROUP_LEN  136
#define MSG_ACTAS_LEN  64

typedef struct ClientMsg__ {
    u_int cmd;
    u_int seq;
    u_char id[64];
    u_char group[136];
    u_char actas[64];
} ClientMsg_, *ClientMsg;

/* Messages to module */

#define RESP_INVALID 0

typedef struct ResponseMsg__ {
    u_int seq;
    u_int resp;
} ResponseMsg_, *ResponseMsg;


/* -------- gwsd config ------------------------ */

typedef struct GWSConfig_ {
  CURL *curl;
  char *url;
  char *ca;    /* certdb */
  char *crt;   /* cert for bind */
  char *key;   /* key for cert bind */
  char *socket_path;      /* gwsd socket name */
  char *client_pw;        /* pw for clients */
  char *actas_hdr;
  char *ding_service;
  char *proxd_host;
  char *proxd_service;
  char *pid_file;
} GWSConfig;

extern int num_client;

